import React from 'react';
import { Atom, WritableAtom, AnyAtom } from './types';
export declare type AtomState<Value = unknown> = {
    promise: Promise<void> | null;
    value: Value;
};
declare type State = Map<AnyAtom, AtomState>;
declare type PartialState = State;
export declare type Actions = {
    add: <Value>(id: symbol, atom: Atom<Value>, partialState?: PartialState) => void;
    del: (id: symbol) => void;
    read: <Value>(state: State, atom: Atom<Value>) => readonly [Promise<void> | null, Value | null, PartialState];
    write: <Value, Update>(atom: WritableAtom<Value, Update>, update: Update) => void;
};
export declare const ActionsContext: React.Context<Actions>;
export declare const StateContext: React.Context<State>;
export declare const Provider: React.FC;
export {};
